#import <Cocoa/Cocoa.h>

enum KeyTag {
    FileName = 1,
    From,
    Subject,
    To,
    Date,
};

enum StringCompareTag {
    Contain = 1,
    BeginWith,
    EndWith,
    CoincideWith,
};

enum DateCompareTag{
    DateBefore = 1,
    DateUntill,
    DateSince,
    DateAfter,
    DateAt,
};

@class Network;

@interface OME_Move : NSObject
{
    IBOutlet NSWindow *mainWindow;
    IBOutlet NSWindow *settingWindow;
    NSMutableArray *moveList;
    IBOutlet NSFormCell *fromFolderField;
    IBOutlet NSPopUpButton *keyPopUp;
    IBOutlet NSTextField *conditionField;
    IBOutlet NSPopUpButton *comparePopUp;
    IBOutlet NSFormCell *toFolderField;
    IBOutlet NSTableView *moveListTable;
    int execTime;
	NSTimer *execTimer;
    BOOL timerIsValid; /* isValid method works wrong */
    IBOutlet NSTextField *countDownField;
    double conditionY;
    double compareY;
    IBOutlet NSTextField *yearField;
    IBOutlet NSTextField *yearLabel;
    IBOutlet NSTextField *monthField;
    IBOutlet NSTextField *monthLabel;
    IBOutlet NSTextField *dayField;
    IBOutlet NSTextField *dayLabel;
    IBOutlet NSPopUpButton *dateComparePopUp;
	IBOutlet NSButton *settingButton;
}


- (id) moveListTableColumn: (NSTableColumn *)tableColumn
		row: (int)row;
- (IBAction) doSetting: (NSButton *)sender;
- (IBAction) addToList: (NSButton *)sender;
- (IBAction) modifyList: (NSButton *) sender;
- (NSMutableDictionary *) setRule;
- (IBAction) moveListClick: (id)sender;
- (IBAction) chooseKey: (NSPopUpButton *) pop;
- (void) moveUIByKey: (int) key;
- (void) setHeight: (double) y ofView: (NSView *) view;
- (IBAction) removeListItem: (NSButton *)sender;
- (IBAction) setDefaultHost: (NSButton *)sender;
- (IBAction) moveAndTerminate: (id) sender;
- (IBAction) move: (id) sender;
- (void) moveByFileNameFrom: (NSString *)fromFolder
                    withRule: (NSDictionary *)moveRule;
- (void) moveByStringHeaderOf: (int) key From: (NSString *)fromFolder
                    withRule: (NSDictionary *)moveRule;
- (int) compareString: (NSString *) string toKeyword: (NSString *) keyword
            withRule: (int) rule;
- (int) compareDateString: (NSString *) string withDate: (NSCalendarDate *) date
            withRule: (int) rule;
- (NSString *) attatchedReadFile: (NSString *) fromFile inFolder: (NSString *) fromFolder;
- (NSString *) headerValue: (int) key ofFile: (NSString *) readFile;
- (void) countDown: (NSTimer *) timer;
- (IBAction) chooseFromFolder: (NSButton *) sender;
- (IBAction) chooseToFolder: (NSButton *) sender;
- (NSString *) chooseFolder;
@end
